"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const escape_string_regexp_1 = tslib_1.__importDefault(require("escape-string-regexp"));
class InterpolateHtmlPlugin {
    constructor(replacements) {
        this.replacements = replacements;
    }
    apply(compiler) {
        const replacements = this.replacements;
        compiler.hooks.compilation.tap('InterpolateHtmlPlugin', (compilation) => {
            // @ts-ignore
            compilation.hooks.htmlWebpackPluginBeforeHtmlProcessing.tapAsync('InterpolateHtmlPlugin', (data, cb) => {
                Object.keys(replacements).forEach(key => {
                    // @ts-ignore
                    const value = replacements[key];
                    data.html = data.html.replace(new RegExp('%' + escape_string_regexp_1.default(key) + '%', 'g'), value);
                });
                cb(null, data);
            });
        });
    }
}
exports.default = InterpolateHtmlPlugin;
